package com.widget.imagevideobanner.bean;

import android.support.annotation.Nullable;
import android.text.TextUtils;

import java.io.Serializable;

/**
 * 资源类型
 */
public class MediaBean implements Serializable {

    public static final int TYPE_IMAGE = 0;//图片
    public static final int TYPE_VIDEO = 1;//视频

    private String url;
    //资源类型
    private int resType;
    //视频的封面
    private String cover;

    private int width;
    private int height;

    public String getUrl() {
        return url;
    }

    public void setUrl(String url) {
        this.url = url;
    }

    public int getResType() {
        return resType;
    }

    public void setResType(int resType) {
        this.resType = resType;
    }

    public String getCover() {
        return cover;
    }

    public void setCover(String cover) {
        this.cover = cover;
    }

    public int getWidth() {
        return width;
    }

    public void setWidth(int width) {
        this.width = width;
    }

    public int getHeight() {
        return height;
    }

    public void setHeight(int height) {
        this.height = height;
    }

    @Override
    public boolean equals(@Nullable Object obj) {
        if (!(obj instanceof MediaBean))
            return false;

        MediaBean mediaBean = (MediaBean) obj;
        return  resType == mediaBean.resType
                && width == mediaBean.width
                && height == mediaBean.height
                && TextUtils.equals(url, mediaBean.url)
                && TextUtils.equals(cover, mediaBean.cover);
    }

    public boolean isNull() {
        if (resType == TYPE_IMAGE) {
            return TextUtils.isEmpty(url) ;
        }
        return (width == 0) || (height == 0)
                || TextUtils.isEmpty(cover)
                || TextUtils.isEmpty(url) ;
    }

}
